// Copyright (C) 1996 DIMACS Center, Rutgers, The State University of New Jersey
// Author(s): Jonathan Berry
// This software is copyrighted by the DIMACS Center at Rutgers, The State
// University of New Jersey.  IT IS PROVIDED AS IS, AND THE AUTHORS, DIMACS, AND
// RUTGERS, THE STATE UNIVERSITY OF NEW JERSEY  DISCLAIM
// ALL LIABILITY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL
// DAMAGES ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY
// DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
// THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE
// IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE
// NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
// MODIFICATIONS.
// The authors hereby grant permission to use, copy, modify, distribute,
// and license this software and its documentation for any purpose, provided
// that existing copyright notices are retained in all copies and that this
// notice is included verbatim in any distributions. No written agreement,
// license, or royalty fee is required for any of the authorized uses.
// Modifications to this software may be copyrighted by their authors
// and need not follow the licensing terms described here, provided that
// the new terms are clearly indicated on the first page of each file where
// they apply.
// Last File Update: 7-Aug-1997
// 
#ifndef ARRAYWRAPPER_H
#define ARRAYWRAPPER_H
#include <stk.h>
#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/stkWrapper.h>
#include <LINK/basic/Array.h>
template <class Item> class ArrayWrapper {
public:
	static void 		markTypedArray(SCM p);
	static void 		freeTypedArray(SCM p);
	static void 		displayTypedArray(SCM c,SCM port,int mode);
	static PRIMITIVE	linkArrayP(SCM l);
	static PRIMITIVE	makeLinkArray(SCM k);
	static PRIMITIVE	makeFilledLinkArray(SCM k, SCM e);
	static PRIMITIVE	buildLinkArray(SCM l);
	static PRIMITIVE	fillLinkArray(SCM l, SCM e);
	static PRIMITIVE	copyLinkArray(SCM l);
	static PRIMITIVE 	stkList2LinkArray(SCM l);
	static PRIMITIVE 	linkArray2STkList(SCM l);
	static PRIMITIVE	lengthLinkArray(SCM l);
	static PRIMITIVE	eqvLinkArray(SCM l, SCM l2);
	static PRIMITIVE	lthLinkArray(SCM l, SCM l2);
	static PRIMITIVE	leLinkArray(SCM l, SCM l2);
	static PRIMITIVE	grLinkArray(SCM l, SCM l2);
	static PRIMITIVE	geLinkArray(SCM l, SCM l2);
	static PRIMITIVE	setLinkArray(SCM l, SCM k, SCM e);
	static PRIMITIVE	refLinkArray(SCM l, SCM k);
	static PRIMITIVE	resizeLinkArray(SCM l, SCM k);
private:
	static Bool 		isArray (SCM p);
	static Array<Item>* 	getArray(SCM p);
};
//#ifdef DEFINE_ArrayWrapper_TEMPLATE
#include <LINK/stkWrapper/ArrayWrapper.cpp>
//#endif 
#endif 
